unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, RTTICtrls, ThreadUnit;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Memo1: TMemo;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    procedure HandleClick(aButton:TButton;var aThread:TTestThread);
  public

  end;

var
  Form1: TForm1;
  Thread1,Thread2,Thread3: TTestThread;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);

begin
  HandleClick(Button1,Thread1);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  HandleClick(Button2,Thread2);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  HandleClick(Button3,Thread3);
end;

procedure TForm1.HandleClick(aButton: TButton; var aThread: TTestThread);

begin
  If not assigned(aThread) then // create thread
    begin
    aThread := TTestThread.Create(Memo1);
    aButton.Caption:=Format('Stop %d',[aThread.ThreadID]);
    aThread.Start;
    end
  else
    begin
    aThread.Terminate; // terminate thread
    while not aThread.isTerminated do  // wait for thread to terminate
      Application.ProcessMessages;
    FreeAndNil(aThread);
    aButton.Caption:='Start';
    end;
end;

end.

